/* File for  Slopes-systems  implementation

   Finding the minimal basis of a system of linear Diophantine equations
   by the slopes algorithm
*/
/*---------------------------------------------------------------------------*\

   Copyright (c) 1993--2000 Ana Paula Tomas, Miguel Filgueiras /
	DCC-FC & LIACC, Universidade do Porto

#    This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this program.

\*---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------\
   File: slopesext.h
   Contents: external declarations of global vars
   Last changed: 13 April 1997
\-----------------------------------------------------------------------*/

#include "slopessys.h"

extern unsigned char Visited[MAXNODE];

extern int M, N, Cx[MAXDIM], Rx[MAXDIM], Sign[MAXPOW], Oflow, NMSSols, NNodes,
  Layer[MAXDIM], NLayers, FirstNonSol, NCones, Top, EnumVar[MAXDIM], NSols,
  NBCones, NBCone[MAXCONE], Nevars, Im, ActBdr, MaxAbs, SeenSol[MAXSOLS];

extern long int Mat[MAXDIM][MAXDIM], MSSol[MAXMSSOLS][MAXDIM], Det[MAXPOW],
  Herm2[MAXDIM][MAXDIM], YSlop[MAXSLOP], ZSlop[MAXSLOP],
  XSlop[MAXSLOP][MAXDIM-2], EnumVal[MAXDIM], EnumMax[MAXDIM], V[MAXDIM],
  Bound[MAXDIM], BCones[MAXCONE][MAXDIM], Sol[MAXSOLS][MAXDIM], CSol[MAXDIM],
  BoundMat[MAXDIM][MAXDIM];

#ifdef SELSUM
extern long int MSSSum[MAXMSSOLS];
#endif

extern RAT Matrix[MAXDIM][MAXDIM];

             /* At least the first MAXBIT powers of 2 */
extern BITS Bit[], Mask, MSSolMask[MAXMSSOLS], Cone[MAXCONE][2];

extern NODE Node[MAXNODE];

extern char Version[];







